function Plugin.DhInit(baudRate)
	Sync() 
	if nil == baudRate then
         baudRate = 115200
	end
    SetToolBaudRate(baudRate)
	--目前固件有问题，设置波特率后的第一条发送会无效，所以在此添加发送一条无用数据（open）
    GWrite(0x01,{0x01,0x06,0x01,0x03,0x03,0xE8,0x78,0x88})
	Sleep(100)
	
	GWrite(0x01,{0x01,0x06,0x01,0x00,0x00,0xA5,0x48,0x4D})
	Sleep(3000)
end

function Plugin.DhSetForce(force)
    local crc2,crc1 = CRC16({0x01,0x06,0x01,0x01,0x00,force})
	GWrite(0x01,{0x01,0x06,0x01,0x01,0x00,force,crc1,crc2})
end

function Plugin.DhSetPosition(position,delayTime)
	num16 = string.format("%x",tostring(position))
	num16Len = string.len(num16)
	if(num16Len > 2) then
	    byteString1 = string.sub(num16, 0, 1)
		byte1 = tonumber(byteString1, 16)
		
		byteString2 = string.sub(num16, 2, 3)
		byte2 = tonumber(byteString2, 16)
		
		local crc2,crc1 = CRC16({0x01,0x06,0x01,0x03,byte1,byte2})
		Sync() 
        GWrite(0x01,{0x01,0x06,0x01,0x03,byte1,byte2,crc1,crc2})
	else
		local crc2,crc1 = CRC16({0x01,0x06,0x01,0x03,0x00,position})
		Sync() 
        GWrite(0x01,{0x01,0x06,0x01,0x03,0x00,position,crc1,crc2})
	end
	
	local t = type(delayTime);
	if t == "number" then
		Sleep(delayTime)
	end
end

function Plugin.DhGetStatus()
    GWrite(0x01,{0x01,0x03,0x02,0x01,0x00,0x01,0xD4,0x72})
	local value = GRead(0x01)
	if value ~= nil and value.size == 7 then 
		return value.buf[5]
	end	
	return -1
end

function Plugin.DhGetPosition()
    GWrite(0x01,{0x01,0x03,0x02,0x02,0x00,0x01,0x24,0x72})
	local value = GRead(0x01)
	if value ~= nil and value.size == 7 then 
		return value.buf[4] * 256 + value.buf[5]
	end	
	return -1
end

function Plugin.DhOpen(delayTime)
	Sync() 
    GWrite(0x01,{0x01,0x06,0x01,0x03,0x03,0xE8,0x78,0x88})
	
	local t = type(delayTime);
	if t == "number" then
		Sleep(delayTime)
	end
end

function Plugin.DhClose(delayTime)
	Sync() 
    GWrite(0x01,{0x01,0x06,0x01,0x03,0x00,0x00,0x78,0x36})
	
	local t = type(delayTime);
	if t == "number" then
		Sleep(delayTime)
	end
end
